Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -2312,40 +1906,43 @@
           CASE ( 'e' )
              IF ( constant_diffusion )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'constant_diffusion = .FALSE.'
-                CALL message( 'check_parameters', 'PA0103', 1, 2, 0, 6, 0 )
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires constant_diffusion = .FALSE.'
+                ENDIF
+                CALL local_stop
              ENDIF
              unit = 'm2/s2'
-
-          CASE ( 'thetal' )
-             IF ( .NOT. bulk_cloud_model )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'bulk_cloud_model = .TRUE.'
-                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'K'
 
           CASE ( 'pc', 'pr' )
              IF ( .NOT. particle_advection )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'a "particle_parameters"-NAMELIST in the parameter file (PARIN)'
-                CALL message( 'check_parameters', 'PA0104', 1, 2, 0, 6, 0 )
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires particle package'
+                   PRINT*, '                      (mrun-option "-p particles")'
+                ENDIF
+                CALL local_stop
              ENDIF
              IF ( TRIM( var ) == 'pc' )  unit = 'number'
              IF ( TRIM( var ) == 'pr' )  unit = 'm'
 
-          CASE ( 'q', 'thetav' )
-             IF ( .NOT. humidity )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires humidity = .TRUE.'
-                CALL message( 'check_parameters', 'PA0105', 1, 2, 0, 6, 0 )
+          CASE ( 'q', 'vpt' )
+             IF ( .NOT. moisture )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires moisture = .TRUE.'
+                ENDIF
+                CALL local_stop
              ENDIF
              IF ( TRIM( var ) == 'q'   )  unit = 'kg/kg'
-             IF ( TRIM( var ) == 'thetav' )  unit = 'K'
+             IF ( TRIM( var ) == 'vpt' )  unit = 'K'
 
           CASE ( 'ql' )
-             IF ( .NOT.  ( bulk_cloud_model  .OR.  cloud_droplets ) )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'bulk_cloud_model = .TRUE. or cloud_droplets = .TRUE.'
-                CALL message( 'check_parameters', 'PA0106', 1, 2, 0, 6, 0 )
+             IF ( .NOT. ( cloud_physics  .OR.  cloud_droplets ) )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires cloud_physics = .TRUE.'
+                   PRINT*, '                      or cloud_droplets = .TRUE.'
+                ENDIF
+                CALL local_stop
              ENDIF
              unit = 'kg/kg'
@@ -2353,7 +1950,9 @@
           CASE ( 'ql_c', 'ql_v', 'ql_vp' )
              IF ( .NOT. cloud_droplets )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'cloud_droplets = .TRUE.'
-                CALL message( 'check_parameters', 'PA0107', 1, 2, 0, 6, 0 )
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires cloud_droplets = .TRUE.'
+                ENDIF
+                CALL local_stop
              ENDIF
              IF ( TRIM( var ) == 'ql_c'  )  unit = 'kg/kg'
@@ -2362,8 +1961,10 @@
 
           CASE ( 'qv' )
-             IF ( .NOT. bulk_cloud_model )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'bulk_cloud_model = .TRUE.'
-                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
+             IF ( .NOT. cloud_physics )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires cloud_physics = .TRUE.'
+                ENDIF
+                CALL local_stop
              ENDIF
              unit = 'kg/kg'
@@ -2371,13 +1972,35 @@
           CASE ( 's' )
              IF ( .NOT. passive_scalar )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'passive_scalar = .TRUE.'
-                CALL message( 'check_parameters', 'PA0110', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'kg/m3'
-
-          CASE ( 'p', 'theta', 'u', 'v', 'w' )
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires passive_scalar = .TRUE.'
+                ENDIF
+                CALL local_stop
+             ENDIF
+             unit = 'conc'
+
+          CASE ( 'u*', 't*', 'lwp*' )
+             IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters:  illegal value for data_',&
+                                'output: "', TRIM( var ), '" is only allowed'
+                   PRINT*, '                       for horizontal cross section'
+                ENDIF
+                CALL local_stop
+             ENDIF
+             IF ( TRIM( var ) == 'lwp*'  .AND.  .NOT. cloud_physics )  THEN
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: output of "', TRIM( var ), &
+                                '" requires cloud_physics = .TRUE.'
+                ENDIF
+                CALL local_stop
+             ENDIF
+             IF ( TRIM( var ) == 'u*'   )  unit = 'm/s'
+             IF ( TRIM( var ) == 't*'   )  unit = 'K'
+             IF ( TRIM( var ) == 'lwp*' )  unit = 'kg/kg*m'
+
+          CASE ( 'p', 'pt', 'u', 'v', 'w' )
              IF ( TRIM( var ) == 'p'  )  unit = 'Pa'
-             IF ( TRIM( var ) == 'theta' )  unit = 'K'
+             IF ( TRIM( var ) == 'pt' )  unit = 'K'
              IF ( TRIM( var ) == 'u'  )  unit = 'm/s'
              IF ( TRIM( var ) == 'v'  )  unit = 'm/s'
@@ -2385,77 +2008,19 @@
              CONTINUE
 
-          CASE ( 'ghf*', 'lwp*', 'ol*', 'qsurf*', 'qsws*', 'r_a*', 'shf*', 'ssurf*', 'ssws*', 't*',&
-                 'tsurf*', 'us*', 'z0*', 'z0h*', 'z0q*' )
-             IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
-                message_string = 'illegal value for data_output: "' // TRIM( var ) //              &
-                                 '" & only 2d-horizontal cross sections are allowed for this value'
-                CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( TRIM( var ) == 'lwp*'  .AND.  .NOT. bulk_cloud_model )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'bulk_cloud_model = .TRUE.'
-                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws*'  .AND.  .NOT.  humidity )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires humidity = .TRUE.'
-                CALL message( 'check_parameters', 'PA0322', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( TRIM( var ) == 'ghf*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( (  TRIM( var ) == 'r_a*' .OR. TRIM( var ) == 'ghf*' )  .AND.  .NOT. land_surface &
-                   .AND.  .NOT. urban_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'land_surface = .TRUE. or ' // 'urban_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( TRIM( var ) == 'ssws*'  .AND.  .NOT. passive_scalar )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requires ' //                  &
-                                 'passive_scalar = .TRUE.'
-                CALL message( 'check_parameters', 'PA0361', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( TRIM( var ) == 'ghf*'   )  unit = 'W/m2'
-             IF ( TRIM( var ) == 'lwp*'   )  unit = 'kg/m2'
-             IF ( TRIM( var ) == 'ol*'    )  unit = 'm'
-             IF ( TRIM( var ) == 'qsurf*' )  unit = 'kg/kg'
-             IF ( TRIM( var ) == 'qsws*'  )  unit = 'kgm/kgs'
-             IF ( TRIM( var ) == 'r_a*'   )  unit = 's/m'
-             IF ( TRIM( var ) == 'shf*'   )  unit = 'K*m/s'
-             IF ( TRIM( var ) == 'ssurf*' )  unit = 'kg/kg'
-             IF ( TRIM( var ) == 'ssws*'  )  unit = 'kg/m2*s'
-             IF ( TRIM( var ) == 't*'     )  unit = 'K'
-             IF ( TRIM( var ) == 'tsurf*' )  unit = 'K'
-             IF ( TRIM( var ) == 'us*'    )  unit = 'm/s'
-             IF ( TRIM( var ) == 'z0*'    )  unit = 'm'
-             IF ( TRIM( var ) == 'z0h*'   )  unit = 'm'
-!
-!--          Output of surface latent and sensible heat flux will be in W/m2 in case of natural- and
-!--          urban-type surfaces, even if flux_output_mode is set to kinematic units.
-             IF ( land_surface  .OR.  urban_surface )  THEN
-                IF ( TRIM( var ) == 'shf*'   )  unit = 'W/m2'
-                IF ( TRIM( var ) == 'qsws*'  )  unit = 'W/m2'
-             ENDIF
-
           CASE DEFAULT
-!
-!--          Check for other modules
-             CALL module_interface_check_data_output( var, unit, i, j, ilen, k )
+             CALL user_check_data_output( var, unit )
 
              IF ( unit == 'illegal' )  THEN
-                IF ( data_output_user(1) /= ' ' )  THEN
-                   message_string = 'illegal value for data_output or ' //                         &
-                                    'data_output_user = "' // TRIM( data_output(i) ) // '"'
-                   CALL message( 'check_parameters', 'PA0114', 1, 2, 0, 6, 0 )
-                ELSE
-                   message_string = 'illegal value for data_output = "' //                         &
-                                    TRIM( data_output(i) ) // '"'
-                   CALL message( 'check_parameters', 'PA0115', 1, 2, 0, 6, 0 )
-                ENDIF
+                IF ( myid == 0 )  THEN
+                   IF ( data_output_user(1) /= ' ' )  THEN
+                      PRINT*, '+++ check_parameters:  illegal value for data_',&
+                                   'output or data_output_user: "',            &
+                                   TRIM( data_output(i) ), '"'
+                   ELSE
+                      PRINT*, '+++ check_parameters:  illegal value for data_',&
+                                   'output: "', TRIM( data_output(i) ), '"'
+                   ENDIF
+                ENDIF
+                CALL local_stop
              ENDIF
 
@@ -2500,44 +2065,30 @@
 
 !
-!-- Averaged 2d or 3d output requires that an averaging interval has been set
-    IF ( doav_n > 0  .AND.  averaging_interval == 0.0_wp )  THEN
-       WRITE( message_string, * )  'output of averaged quantity "', TRIM( doav(1) ),               &
-                                   '_av" requires to set a ', 'non-zero averaging interval'
-       CALL message( 'check_parameters', 'PA0323', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check sectional planes and store them in one shared array
-    IF ( ANY( section_xy > nz + 1 ) )  THEN
-       WRITE( message_string, * )  'section_xy must be <= nz + 1 = ', nz + 1
-       CALL message( 'check_parameters', 'PA0319', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( ANY( section_xz > ny + 1 ) )  THEN
-       WRITE( message_string, * )  'section_xz must be <= ny + 1 = ', ny + 1
-       CALL message( 'check_parameters', 'PA0320', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( ANY( section_yz > nx + 1 ) )  THEN
-       WRITE( message_string, * )  'section_yz must be <= nx + 1 = ', nx + 1
-       CALL message( 'check_parameters', 'PA0321', 1, 2, 0, 6, 0 )
-    ENDIF
+!-- Store sectional planes in one shared array
     section(:,1) = section_xy
     section(:,2) = section_xz
     section(:,3) = section_yz
 
-    IF ( ANY( data_output_xy )  .AND.  .NOT. ANY( section(:,1) /= -9999 ) )  THEN
-       WRITE( message_string, * )  'section_xy not defined for requested xy-cross section ' //     &
-                                   'output.&At least one cross section must be given.'
-       CALL message( 'check_parameters', 'PA0681', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( ANY( data_output_xz )  .AND.  .NOT. ANY( section(:,2) /= -9999 ) )  THEN
-       WRITE( message_string, * )  'section_xz not defined for requested xz-cross section ' //     &
-                                   'output.&At least one cross section must be given.'
-       CALL message( 'check_parameters', 'PA0681', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( ANY( data_output_yz )  .AND.  .NOT. ANY( section(:,3) /= -9999 ) )  THEN
-       WRITE( message_string, * )  'section_yz not defined for requested yz-cross section ' //     &
-                                   'output.&At least one cross section must be given.'
-       CALL message( 'check_parameters', 'PA0681', 1, 2, 0, 6, 0 )
-    ENDIF
+!
+!-- Upper plot limit (grid point value) for 1D profiles
+    IF ( z_max_do1d == -1.0 )  THEN
+       nz_do1d = nzt+1
+    ELSE
+       DO  k = nzb+1, nzt+1
+          nz_do1d = k
+          IF ( zw(k) > z_max_do1d )  EXIT
+       ENDDO
+    ENDIF
+
+!
+!-- Upper plot limit for 2D vertical sections
+    IF ( z_max_do2d == -1.0 )  z_max_do2d = zu(nzt)
+    IF ( z_max_do2d < zu(nzb+1)  .OR.  z_max_do2d > zu(nzt) )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  z_max_do2d=',        &
+                                 z_max_do2d, ' must be >= ', zu(nzb+1),       &
+                                 '(zu(nzb+1)) and <= ', zu(nzt), ' (zu(nzt))'
+       CALL local_stop
+    ENDIF
+
 !
 !-- Upper plot limit for 3D arrays
